clear
close all
clc

%% funkce k prikladu 4.58 na strane 44 a 45
% author: Patrik Drda
syms x
for i=1:25
   j=(-1)^i;
   if j==-1
       b(i+2)=x;  
   else
       b(i+2)=1;
   end
 a(2*i)=i;
 a(2*i+1)=i;
B(1) =x;
B(2)=x+1;
% rekurentn vztahy, viz (2.7) str. 10
B(i+2)=b(i+2)*B(i+1)+a(i+2)*B(i);

A(1)=x^0;
A(2)=x^0;
% rekurentn vztahy, viz (2.7) str. 10
A(i+2)=b(i+2)*A(i+1)+a(i+2)*A(i);
end
%% hledani neklesajici funkce pro A_9/B_9
g(x)=A(9);
f(x)=B(9);
p=solve(f(x)==0,x); % hledani uzlu
q=sort(p,'descend'); % jejich serazeni od nejmensiho
qq=-q;

h(x)=diff(f(x));

for j=1:length(q)
r(j)=g(q(j))/h(q(j)); % vahy , viz (4.61), str. 40
end
rr=cumsum(r);

%% hledani neklesajici funkce pro A_13/B_13
g1(x)=A(13);
f1(x)=B(13);
p1=solve(f1(x)==0,x); % hledani uzlu
q1=sort(p1,'descend'); % jejich serazeni od nejmensiho
qq1=-q1;

h1(x)=diff(f1(x));

for jj=1:length(q1)
r1(jj)=g1(q1(jj))/h1(q1(jj)); % vahy , viz (4.61), str. 40
end
rr1=cumsum(r1);
%% hledani neklesajici funkce pro A_27/B_27
g2(x)=A(27);
f2(x)=B(27);
p2=solve(f2(x)==0,x); % hledani uzlu
q2=sort(p2,'descend'); % jejich serazeni od nejmensiho
qq2=-q2;

h2(x)=diff(f2(x));   % vahy , viz (4.61), str. 40

for jj=1:length(q2)
r2(jj)=g2(q2(jj))/h2(q2(jj));
end
rr2=cumsum(r2);
%% graficke znazorneni
t=linspace(0,10);
figure
stairs(qq,rr,'k.-','MarkerSize',20)

hold on
stairs(qq1,rr1,'k-.','LineWidth',2)

hold on
stairs(qq2,rr2,'k--o','LineWidth',2)

hold on
y2=1-exp(-t); % reseni problemu momentu (distribucni funkce)
plot(t,y2,'r','LineWidth',2)
xlim([0 10])
ylim([0 1.1])
xlabel('t')
legend('\psi^{(9)}','\psi^{(13)}','\psi^{(27)}','1-e^t','Interpreter','latex', 'Location','southeast');
hold off
